



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Oracle 数据库重放（Database Replay）功能演示</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Oracle 数据库重放（Database Replay）功能演示</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 22:44:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>我们可以捕获生产环境的工作量，在测试环境上重放，从而在不影响生产环境的前提下做一些改动测试。<br /><br />
捕获：需要Oracle版本为10.2.0.4或更高.<br /><br />
重放：需要Oracle版本为11g Release 1或更新.</p>
<p>本文环境：RHEL6.4 + Oracle 11.2.0.4<br /><br />
下面介绍一下执行Database Replay的Workflow。</p>
<ul><li><a href="#1" rel="external nofollow noreferrer">1. 捕获工作量（Workload Capture）</a></li>
<li><a href="#2" rel="external nofollow noreferrer">2. 重放工作量（Workload Replay）</a></li>
<li><a href="#3" rel="external nofollow noreferrer">3. 分析和报告（Analysis and Reporting）</a></li>
<li><a href="#4" rel="external nofollow noreferrer">Reference</a></li></ul>
<h1>1. 捕获工作量（Workload Capture）</h1>
<p>## 1.1 开始捕获 ##<br />
```<br />
-- 创建目录replay_dir存放捕获信息<br />
create or replace directory replay_dir as '/oradata/replay_dir';</p>
<p>-- 开始捕获工作量，10分钟后停止<br /><br />
begin<br /><br />
dbms_workload_capture.start_capture(name =&gt; 'jydb_replay_1', dir =&gt; 'REPLAY_DIR', duration =&gt; 600);<br /><br />
end;<br /><br />
/</p>
<pre class="prettyprint linenums"><code>注：如果duration参数不指定，那么就在执行finish_capture成功后停止捕获。<br />
## 1.2 模拟工作量 ##<br />
</code></pre>
<p>conn system/oracle@productDB</p>
<p>-- 数据表空间<br /><br />
create tablespace dbs_d_jingyu datafile size 30M autoextend off;<br /><br />
-- 临时表空间<br /><br />
create temporary tablespace temp_jingyu tempfile size 30M autoextend off;<br /><br />
-- 索引表空间(可选)<br /><br />
create tablespace dbs_i_jingyu datafile size 30M autoextend off;</p>
<p>-- 假设创建用户 jingyu 密码 jingyu，默认临时表空间 temp_jingyu， 默认数据表空间 dbs_d_jingyu。<br /><br />
CREATE USER jingyu IDENTIFIED BY jingyu<br /><br />
TEMPORARY TABLESPACE temp_jingyu<br /><br />
DEFAULT TABLESPACE dbs_d_jingyu<br /><br />
QUOTA UNLIMITED ON dbs_d_jingyu;</p>
<p>-- 赋予普通业务用户权限<br /><br />
grant resource, connect to jingyu;<br /><br />
-- 赋予DBA用户权限<br /><br />
grant dba to jingyu;</p>
<p>-- 业务用户登录<br /><br />
conn jingyu/jingyu@productDB<br /><br />
-- 删除T1,T2两张表<br /><br />
drop table t1 cascade constraints purge;<br /><br />
drop table t2 cascade constraints purge;<br /><br />
-- 创建T1,T2两张表<br /><br />
create table t1( id number not null, n number, contents varchar2(4000) ) tablespace dbs_d_jingyu;<br /><br />
create table t2( id number not null, t1_id number not null, n number, contents varchar2(4000) ) tablespace dbs_d_jingyu;<br /><br />
-- 初始化向T1,T2表插入随机测试数据<br /><br />
execute dbms_random.seed(0);<br /><br />
set timing on<br /><br />
insert into t1  select rownum, rownum, dbms_random.string('a',50)   from dual   connect by level &lt;= 100   order by dbms_random.random;<br /><br />
commit;<br /><br />
insert into t2  select rownum, rownum, rownum, dbms_random.string('b',50)  from dual  connect by level &lt;= 10000  order by dbms_random.random;<br /><br />
commit;<br /><br />
-- 查询T1,T2表数据量<br /><br />
select count(1) from t1;<br /><br />
select count(1) from t2;</p>
<p>begin<br /><br />
for i in 1..1000<br /><br />
loop<br /><br />
execute immediate 'select t1.id from t1, t2 where t1.id = t2.t1_id and t1.n = 19';<br /><br />
end loop;<br /><br />
end;<br /><br />
/</p>
<p>-- 查询v$sql信息<br /><br />
select t.EXECUTIONS, t.SQL_TEXT from v$sql t where sql_text like 'select t1.id from t1, t2 where t1.id = t2.t1_id and t1.n = 19';</p>
<pre class="prettyprint linenums"><code>## 1.3 完成捕获 ##<br />
</code></pre>
<p>-- 停止捕获工作量<br /><br />
exec dbms_workload_capture.finish_capture();</p>
<pre class="prettyprint linenums"><code>&lt;h1 id=&quot;2&quot;&gt;2. 重放工作量（Workload Replay）&lt;/h1&gt;<br />
## 2.1 测试环境准备 ##<br />
首先将目录中生成的文件全部迁移到测试环境B目录/u02/replay_dir中。<br />
</code></pre>
<p>-- 以下步骤是在测试环境B执行</p>
<p>-- 创建目录replay_dir<br /><br />
create or replace directory replay_dir as '/u02/replay_dir';</p>
<pre class="prettyprint linenums"><code>## 2.2 预处理工作量 ##<br />
</code></pre>
<p>-- 预处理工作量<br /><br />
begin<br /><br />
dbms_workload_replay.process_capture(capture_dir =&gt; 'REPLAY_DIR');<br /><br />
dbms_workload_replay.initialize_replay('jydb_replay_1', 'REPLAY_DIR');<br /><br />
dbms_workload_replay.PREPARE_REPLAY();<br /><br />
end;<br /><br />
/</p>
<pre class="prettyprint linenums"><code>## 2.3 重放工作量 ##<br />
</code></pre>
<p>-- 重放工作量 （发现有问题）<br /><br />
exec dbms_workload_replay.start_replay();</p>
<p>-- 报错信息<br /><br />
*<br /><br />
ERROR at line 1:<br /><br />
ORA-20223: No replay clients have connected yet! Please issue START_REPLAY()<br /><br />
after one or more WRC replay clients have been started!<br /><br />
ORA-06512: at &quot;SYS.DBMS_WORKLOAD_REPLAY&quot;, line 5748<br /><br />
ORA-06512: at line 1</p>
<p>--查询<br /><br />
SELECT * FROM v$option WHERE parameter = 'Real Application Testing';</p>
<pre class="prettyprint linenums"><code>上述报错因为没有WRC重放客户端，至少有1个WRC重放客户端。<br />
### 2.3.1 需要WRC模拟重演客户端 ###<br />
wrc mode=calibrate replaydir=/u02/replay_dir<br />
</code></pre>
<p>[oracle@JY-DB01 replay_dir]$ wrc mode=calibrate replaydir=/u02/replay_dir</p>
<pre class="prettyprint linenums"><code>wrc system/oracle@testDB mode=replay replaydir=/u02/replay_dir<br />
</code></pre>
<p>[oracle@JY-DB01 admin]$ wrc system/oracle@testDB mode=replay replaydir=/u02/replay_dir</p>
<pre class="prettyprint linenums"><code>### 2.3.2 开始/暂停/继续/终止重放 ###<br />
</code></pre>
<p>-- 开始重放<br /><br />
exec dbms_workload_replay.start_replay();</p>
<p>-- 暂停重放<br /><br />
exec dbms_workload_replay.pause_replay();<br /><br />
-- 继续重放<br /><br />
exec dbms_workload_replay.resume_replay();<br /><br />
-- 终止重放<br /><br />
exec dbms_workload_replay.cancel_replay();</p>
<pre class="prettyprint linenums"><code>### 2.3.3 验证重放结果 ###<br />
</code></pre>
<p>-- t1表数量 应该是100<br /><br />
select count(1) from jingyu.t1;<br /><br />
-- t2表数量 应该是10000<br /><br />
select count(1) from jingyu.t2;<br /><br />
-- 查询v$sql信息 应该是1000<br /><br />
select t.EXECUTIONS, t.SQL_TEXT from v$sql t where sql_text like 'select t1.id from t1, t2 where t1.id = t2.t1_id and t1.n = 19';</p>
<pre class="prettyprint linenums"><code>&lt;h1 id=&quot;3&quot;&gt;3. 分析和报告（Analysis and Reporting）&lt;/h1&gt;<br />
## 3.1 productDB部分 ##<br />
</code></pre>
<p>-- 查询捕获信息<br /><br />
SELECT DBMS_WORKLOAD_CAPTURE.get_capture_info('REPLAY_DIR') FROM dual;</p>
<p>-- 提取报告<br /><br />
BEGIN<br /><br />
DBMS_WORKLOAD_CAPTURE.export_awr (capture_id =&gt; 18);<br /><br />
END;<br /><br />
/</p>
<p>-- 查询dba_workload_captures<br /><br />
select id, name from dba_workload_captures;</p>
<p>-- 删除捕获信息<br /><br />
exec dbms_workload_capture.delete_capture_info(&amp;i);<br /><br />
输入上面查询dba_workload_captures的id值进行删除。</p>
<pre class="prettyprint linenums"><code>## 3.2 testDB部分 ##<br />
</code></pre>
<p>-- 查询dba_workload_replays<br /><br />
COLUMN name FORMAT A30<br /><br />
SELECT id, name FROM dba_workload_replays;</p>
<p>-- 收集报告	<br /><br />
declare<br /><br />
capture_dir_id number;<br /><br />
curr_replay_id number;<br /><br />
replay_report clob;<br /><br />
begin<br /><br />
capture_dir_id := dbms_workload_replay.get_replay_info(dir =&gt; 'REPLAY_DIR');<br /><br />
select max(id) into curr_replay_id from dba_workload_replays where capture_id = capture_dir_id;<br /><br />
replay_report := dbms_workload_replay.report(replay_id =&gt; curr_replay_id, format =&gt; DBMS_WORKLOAD_REPLAY.TYPE_HTML);<br /><br />
end;<br /><br />
/</p>
<p>--删除重放信息<br /><br />
exec dbms_workload_replay.delete_replay_info(&amp;i);<br /><br />
输入上面查询dba_workload_replays的id值进行删除。<br /><br />
另，在确定不需要的时候可以系统删除重放目录下文件。</p>
<pre class="prettyprint linenums"><code>&lt;h1 id=&quot;4&quot;&gt;Reference&lt;/h1&gt;<br />
- [Database Replay in Oracle Database 11g Release 1](https://oracle-base.com/articles/11g/database-replay-11gr1)<br />
- OCP 认证考试指南 (1Z0-053)[M]. 清华大学出版社, 2010.</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j0rv4q.html">jquery Combo Select  下拉框可选可输入插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e5drm8.html">Mybatis映射文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q20oox9.html">软件测试第六周学习笔记之&OpenCurlyDoubleQuote;Win8 APP应用程序的白盒测试&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx530d8.html">承接Hololens内容定制外包</a>
		</li>
						<li><a href="https://www.batexi.com/a/3900ppo9.html">bbed的使用--安装及初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o7251q.html">基因变异（codevs 3194）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k30e6q.html">Quartz与Spring整合进行热部署的实现（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx0em0q.html">DOS实用命令&sol;工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w0mevq.html">&lbrack;Java&rsqb; 模拟HTTP的Get和Post请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn6lwv8.html">Java反转单链表&lpar;code&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okekgl9.html">转：Node&period;js软肋之CPU密集型任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdd5dd9.html">Sqlserver 高并发和大数据存储方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpjmdr9.html">20款最好的免费的IDES和编辑器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj5ke5q.html">HBase介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj4wg28.html">搭建yeoman自动化构建工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jyoo38.html">02-线性结构4 Pop Sequence</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljxmy19.html">Linux基础-最基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojrm2pq.html">Android中R文件的丢失问题以及aapt&period;exe停止工作如何解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pwy738.html">How tomcat works 读书笔记十四 服务器组件和服务组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j4zr0q.html">l&Hat;oo不可分的两个注意点</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9jzyrg8.html">python 之 Django 基础篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pd14y9.html">iOS 10 开发问题总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pd1149.html">python 中使用 global 引发了莫名其妙的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e4elm9.html">C&num;简单的上位机制作之界面设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pwjek8.html">java &period;bat批处理（java cmd命令）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pwdkz8.html">Android课程---关于Service的学习&lpar;后台运行&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e4y2e9.html">Jquery 仿 android Toast效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9600mv9.html">org&period;apache&period;jasper&period;JasperException&colon;省略&amp;quot&semi;&sol;html&sol;sysmaintain&sol;authority&sol;user&sol;&period;&period;&sol;&period;&period;&sol;module&sol;verify&lowbar;login&period;jsp&amp;quot&semi; not found</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pwpok8.html">Kruskal 最小生成树算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqllom6q.html">ASP&period;Net MVC开发基础学习笔记：二、HtmlHelper与扩展方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
